import java.applet.*;
import java.awt.*;
import java.awt.Graphics.*;

public class Pong extends Applet implements Runnable
{
static final int DELAY = 50;
    Thread gameLoop;
    int i;
    Image iBuffer;
    Image Background;
    Graphics gBuffer;
    int plrY;
    int cpuY;
    int ballX;
    int ballY;
    int ballSpeedX;
    int ballSpeedY;
    int plrScore;
    int cpuScore;
    String message;
    public void init ()
    {
	GetImages ();
	iBuffer = createImage (325, 300);
	gBuffer = iBuffer.getGraphics ();
	plrScore = 0;
	cpuScore = 0;
	plrY = 10;
	cpuY = 150;
	message = " Press [Space] to start.";
	ballX = (int) Math.random () * 100 + 100;
	ballY = 50;
	ballSpeedX = 5;
	ballSpeedY = 5;
	gameLoop = new Thread (this);
    }


    public void start ()
    {

	if (gameLoop == null)
	{
	    gameLoop = new Thread (this);
	    gameLoop.start ();
	}
    }


    public void stop ()
    {

	if (gameLoop != null)
	{
	    gameLoop.stop ();
	    gameLoop = null;
	}
    }


    public void run ()
    {
	long startTime;

	// Lower this thread's priority and get the current time.

	Thread.currentThread ().setPriority (Thread.MIN_PRIORITY);
	startTime = System.currentTimeMillis ();
	while (Thread.currentThread () == gameLoop)
	{

	    ballX += ballSpeedX;
	    ballY += ballSpeedY;
	    //left paddle collision
	    if (ballX < 20 && ballX > 10 && ballY < plrY + 70 && ballY > plrY && ballSpeedX < 0)
	    {
		ballX = 20;
		ballSpeedX -= ballSpeedX * 2 + 1;
	    }
	    //top collision
	    if (ballY < 0)
	    {
		ballY = 0;
		ballSpeedY -= ballSpeedY * 2 + 1;
	    }
	    //bottom collision
	    if (ballY > 220)
	    {
		ballY = 220;
		ballSpeedY -= ballSpeedY * 2 + 1;
	    }
	    //right paddle collision
	    if (ballX > 300 && ballX < 310 && ballY < cpuY + 70 && ballY > cpuY && ballSpeedX > 0)
	    {
		ballX = 300;
		ballSpeedX -= ballSpeedX * 2 + 1;
	    }

	    if (cpuY + 35 < ballY && cpuY + 70 < 230)
	    {
		cpuY += 2;
	    }

	    if (cpuY + 35 > ballY && cpuY > 0)
	    {
		cpuY -= 2;
	    }

	    if (ballX < 0)
	    {
		cpuScore++;
		ballX = (int) Math.random () * 100 + 100;
		ballSpeedX = 4;
		ballSpeedY = 2;
		try
		{
		    gameLoop.sleep (3000);
		}
		catch (InterruptedException e)
		{
		    ;
		}
	    }

	    if (ballX > 315)
	    {
		plrScore++;
		ballX = (int) Math.random () * 100 + 100;
		ballSpeedX = 4;
		ballSpeedY = 2;

	    }

	    repaint ();
	    try
	    {
			    startTime += DELAY;
		Thread.sleep (Math.max (0, startTime - System.currentTimeMillis ()));
	    }
	    catch (InterruptedException e)
	    {
		break;
	    }
	}
    }


    MediaTracker thetracker = null;
    public void GetImages ()
    {
	thetracker = new MediaTracker (this);

	Background = getImage (getDocumentBase (), "Soccer Field.PNG");
	thetracker.addImage (Background, 0);

	try
	{
	    thetracker.waitForAll ();
	}
	catch (InterruptedException e)
	{
	    return;
	}
    }


    public void paint (Graphics g)
    {
	Dimension d = size ();
	if (gBuffer == null)
	{
	    iBuffer = createImage (d.width, d.height);
	    gBuffer = iBuffer.getGraphics ();
	}
	gBuffer.drawImage (Background, 0, 0, this);
	gBuffer.setColor (Color.green);
	//gBuffer.fillRect (0, 0, 325, 300);
	gBuffer.setColor (Color.black);
	gBuffer.fillRect (10, plrY, 10, 70);
	gBuffer.fillRect (310, cpuY, 10, 70);
	gBuffer.drawString ("You: " + plrScore, 10, 245);
	gBuffer.drawString ("Comp: " + cpuScore, 270, 245);
	gBuffer.setColor (Color.black);
	gBuffer.drawLine (0, 230, 325, 230);
	gBuffer.fillOval (ballX, ballY, 10, 10);
	gBuffer.drawString (message, 10, 10);

	g.drawImage (iBuffer, 0, 0, this);
    }


    public boolean mouseMove (Event e, int x, int y)
    {
	plrY = y - 35;

	if (plrY < 0)
	{
	    plrY = 0;
	}

	if (plrY + 70 > 230)
	{
	    plrY = 230 - 70;
	}
	return true;
    }


    public boolean keyDown (Event e, int key)
    {
	switch (key)
	{
	    case 32:
		if (message != "")
		{
		    gameLoop.start ();
		    message = "";
		}
	}

	return true;
    }
}


